/* plugin-application.c generated by valac 0.48.5, the Vala compiler
 * generated from plugin-application.vala, do not modify */

/*
 * Copyright © 2020 Michael Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later). See the COPYING file in this distribution.
 */

#include <glib-object.h>
#include "geary-engine.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <gee.h>

#define PLUGIN_TYPE_APPLICATION (plugin_application_get_type ())
#define PLUGIN_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PLUGIN_TYPE_APPLICATION, PluginApplication))
#define PLUGIN_IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PLUGIN_TYPE_APPLICATION))
#define PLUGIN_APPLICATION_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), PLUGIN_TYPE_APPLICATION, PluginApplicationIface))

typedef struct _PluginApplication PluginApplication;
typedef struct _PluginApplicationIface PluginApplicationIface;

#define PLUGIN_TYPE_ACCOUNT (plugin_account_get_type ())
#define PLUGIN_ACCOUNT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PLUGIN_TYPE_ACCOUNT, PluginAccount))
#define PLUGIN_IS_ACCOUNT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PLUGIN_TYPE_ACCOUNT))
#define PLUGIN_ACCOUNT_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), PLUGIN_TYPE_ACCOUNT, PluginAccountIface))

typedef struct _PluginAccount PluginAccount;
typedef struct _PluginAccountIface PluginAccountIface;

#define PLUGIN_TYPE_COMPOSER (plugin_composer_get_type ())
#define PLUGIN_COMPOSER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PLUGIN_TYPE_COMPOSER, PluginComposer))
#define PLUGIN_IS_COMPOSER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PLUGIN_TYPE_COMPOSER))
#define PLUGIN_COMPOSER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), PLUGIN_TYPE_COMPOSER, PluginComposerIface))

typedef struct _PluginComposer PluginComposer;
typedef struct _PluginComposerIface PluginComposerIface;

#define PLUGIN_TYPE_EMAIL_IDENTIFIER (plugin_email_identifier_get_type ())
#define PLUGIN_EMAIL_IDENTIFIER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PLUGIN_TYPE_EMAIL_IDENTIFIER, PluginEmailIdentifier))
#define PLUGIN_IS_EMAIL_IDENTIFIER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PLUGIN_TYPE_EMAIL_IDENTIFIER))
#define PLUGIN_EMAIL_IDENTIFIER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), PLUGIN_TYPE_EMAIL_IDENTIFIER, PluginEmailIdentifierIface))

typedef struct _PluginEmailIdentifier PluginEmailIdentifier;
typedef struct _PluginEmailIdentifierIface PluginEmailIdentifierIface;

#define PLUGIN_TYPE_FOLDER (plugin_folder_get_type ())
#define PLUGIN_FOLDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PLUGIN_TYPE_FOLDER, PluginFolder))
#define PLUGIN_IS_FOLDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PLUGIN_TYPE_FOLDER))
#define PLUGIN_FOLDER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), PLUGIN_TYPE_FOLDER, PluginFolderIface))

typedef struct _PluginFolder PluginFolder;
typedef struct _PluginFolderIface PluginFolderIface;

struct _PluginAccountIface {
	GTypeInterface parent_iface;
	const gchar* (*get_display_name) (PluginAccount* self);
};

struct _PluginEmailIdentifierIface {
	GTypeInterface parent_iface;
	PluginAccount* (*get_account) (PluginEmailIdentifier* self);
	GVariant* (*to_variant) (PluginEmailIdentifier* self);
};

struct _PluginFolderIface {
	GTypeInterface parent_iface;
	const gchar* (*get_persistent_id) (PluginFolder* self);
	const gchar* (*get_display_name) (PluginFolder* self);
	GearyFolderSpecialUse (*get_used_as) (PluginFolder* self);
	PluginAccount* (*get_account) (PluginFolder* self);
	GVariant* (*to_variant) (PluginFolder* self);
};

struct _PluginComposerIface {
	GTypeInterface parent_iface;
	gboolean (*get_can_send) (PluginComposer* self);
	void (*set_can_send) (PluginComposer* self, gboolean value);
	void (*show) (PluginComposer* self);
	void (*edit_email) (PluginComposer* self, PluginEmailIdentifier* to_load, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*edit_email_finish) (PluginComposer* self, GAsyncResult* _res_, GError** error);
	void (*save_to_folder) (PluginComposer* self, PluginFolder* location);
};

typedef enum  {
	PLUGIN_ERROR_PERMISSION_DENIED,
	PLUGIN_ERROR_NOT_FOUND,
	PLUGIN_ERROR_NOT_SUPPORTED
} PluginError;
#define PLUGIN_ERROR plugin_error_quark ()
struct _PluginApplicationIface {
	GTypeInterface parent_iface;
	PluginComposer* (*new_composer) (PluginApplication* self, PluginAccount* source, GError** error);
	void (*register_action) (PluginApplication* self, GAction* action);
	void (*deregister_action) (PluginApplication* self, GAction* action);
	void (*show_folder) (PluginApplication* self, PluginFolder* folder);
	void (*empty_folder) (PluginApplication* self, PluginFolder* folder, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*empty_folder_finish) (PluginApplication* self, GAsyncResult* _res_, GError** error);
};

GType plugin_account_get_type (void) G_GNUC_CONST;
GType plugin_email_identifier_get_type (void) G_GNUC_CONST;
GType plugin_folder_get_type (void) G_GNUC_CONST;
GType plugin_composer_get_type (void) G_GNUC_CONST;
GQuark plugin_error_quark (void);
GType plugin_application_get_type (void) G_GNUC_CONST;
PluginComposer* plugin_application_new_composer (PluginApplication* self,
                                                 PluginAccount* source,
                                                 GError** error);
void plugin_application_register_action (PluginApplication* self,
                                         GAction* action);
void plugin_application_deregister_action (PluginApplication* self,
                                           GAction* action);
void plugin_application_show_folder (PluginApplication* self,
                                     PluginFolder* folder);
void plugin_application_empty_folder (PluginApplication* self,
                                      PluginFolder* folder,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_);
void plugin_application_empty_folder_finish (PluginApplication* self,
                                             GAsyncResult* _res_,
                                             GError** error);
static GType plugin_application_get_type_once (void);

/**
     * Constructs a new, blank composer for the given account.
     *
     * The composer will be initialised to send an email from the
     * given account. This may be changed by people before they send
     * the email, however.
     */
PluginComposer*
plugin_application_new_composer (PluginApplication* self,
                                 PluginAccount* source,
                                 GError** error)
{
	g_return_val_if_fail (PLUGIN_IS_APPLICATION (self), NULL);
	return PLUGIN_APPLICATION_GET_INTERFACE (self)->new_composer (self, source, error);
}

/**
     * Registers a plugin action with the application.
     *
     * Once registered, the action will be available for use in user
     * interface elements such as {@link Button}.
     *
     * @see deregister_action
     */
void
plugin_application_register_action (PluginApplication* self,
                                    GAction* action)
{
	g_return_if_fail (PLUGIN_IS_APPLICATION (self));
	PLUGIN_APPLICATION_GET_INTERFACE (self)->register_action (self, action);
}

/**
     * De-registers a plugin action with the application.
     *
     * Makes a previously registered no longer available.
     *
     * @see register_action
     */
void
plugin_application_deregister_action (PluginApplication* self,
                                      GAction* action)
{
	g_return_if_fail (PLUGIN_IS_APPLICATION (self));
	PLUGIN_APPLICATION_GET_INTERFACE (self)->deregister_action (self, action);
}

/** Displays a folder in the most recently used main window. */
void
plugin_application_show_folder (PluginApplication* self,
                                PluginFolder* folder)
{
	g_return_if_fail (PLUGIN_IS_APPLICATION (self));
	PLUGIN_APPLICATION_GET_INTERFACE (self)->show_folder (self, folder);
}

void
plugin_application_empty_folder (PluginApplication* self,
                                 PluginFolder* folder,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_)
{
	PLUGIN_APPLICATION_GET_INTERFACE (self)->empty_folder (self, folder, _callback_, _user_data_);
}

void
plugin_application_empty_folder_finish (PluginApplication* self,
                                        GAsyncResult* _res_,
                                        GError** error)
{
	PLUGIN_APPLICATION_GET_INTERFACE (self)->empty_folder_finish (self, _res_, error);
}

static void
plugin_application_default_init (PluginApplicationIface * iface,
                                 gpointer iface_data)
{
}

/**
 * An object representing the client application for use by plugins.
 *
 * Plugins may obtain instances of this object from the {@link
 * PluginBase.plugin_application} property.
 */
static GType
plugin_application_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PluginApplicationIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) plugin_application_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType plugin_application_type_id;
	plugin_application_type_id = g_type_register_static (G_TYPE_INTERFACE, "PluginApplication", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (plugin_application_type_id, GEARY_TYPE_BASE_OBJECT);
	return plugin_application_type_id;
}

GType
plugin_application_get_type (void)
{
	static volatile gsize plugin_application_type_id__volatile = 0;
	if (g_once_init_enter (&plugin_application_type_id__volatile)) {
		GType plugin_application_type_id;
		plugin_application_type_id = plugin_application_get_type_once ();
		g_once_init_leave (&plugin_application_type_id__volatile, plugin_application_type_id);
	}
	return plugin_application_type_id__volatile;
}

