/* plugin-composer.c generated by valac 0.48.5, the Vala compiler
 * generated from plugin-composer.vala, do not modify */

/*
 * Copyright © 2020 Michael Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later). See the COPYING file in this distribution.
 */

#include <glib-object.h>
#include "geary-engine.h"
#include <glib.h>
#include <gio/gio.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>

#define PLUGIN_TYPE_COMPOSER (plugin_composer_get_type ())
#define PLUGIN_COMPOSER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PLUGIN_TYPE_COMPOSER, PluginComposer))
#define PLUGIN_IS_COMPOSER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PLUGIN_TYPE_COMPOSER))
#define PLUGIN_COMPOSER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), PLUGIN_TYPE_COMPOSER, PluginComposerIface))

typedef struct _PluginComposer PluginComposer;
typedef struct _PluginComposerIface PluginComposerIface;

#define PLUGIN_TYPE_EMAIL_IDENTIFIER (plugin_email_identifier_get_type ())
#define PLUGIN_EMAIL_IDENTIFIER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PLUGIN_TYPE_EMAIL_IDENTIFIER, PluginEmailIdentifier))
#define PLUGIN_IS_EMAIL_IDENTIFIER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PLUGIN_TYPE_EMAIL_IDENTIFIER))
#define PLUGIN_EMAIL_IDENTIFIER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), PLUGIN_TYPE_EMAIL_IDENTIFIER, PluginEmailIdentifierIface))

typedef struct _PluginEmailIdentifier PluginEmailIdentifier;
typedef struct _PluginEmailIdentifierIface PluginEmailIdentifierIface;

#define PLUGIN_TYPE_ACCOUNT (plugin_account_get_type ())
#define PLUGIN_ACCOUNT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PLUGIN_TYPE_ACCOUNT, PluginAccount))
#define PLUGIN_IS_ACCOUNT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PLUGIN_TYPE_ACCOUNT))
#define PLUGIN_ACCOUNT_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), PLUGIN_TYPE_ACCOUNT, PluginAccountIface))

typedef struct _PluginAccount PluginAccount;
typedef struct _PluginAccountIface PluginAccountIface;

#define PLUGIN_TYPE_FOLDER (plugin_folder_get_type ())
#define PLUGIN_FOLDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PLUGIN_TYPE_FOLDER, PluginFolder))
#define PLUGIN_IS_FOLDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PLUGIN_TYPE_FOLDER))
#define PLUGIN_FOLDER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), PLUGIN_TYPE_FOLDER, PluginFolderIface))

typedef struct _PluginFolder PluginFolder;
typedef struct _PluginFolderIface PluginFolderIface;

struct _PluginAccountIface {
	GTypeInterface parent_iface;
	const gchar* (*get_display_name) (PluginAccount* self);
};

struct _PluginEmailIdentifierIface {
	GTypeInterface parent_iface;
	PluginAccount* (*get_account) (PluginEmailIdentifier* self);
	GVariant* (*to_variant) (PluginEmailIdentifier* self);
};

struct _PluginFolderIface {
	GTypeInterface parent_iface;
	const gchar* (*get_persistent_id) (PluginFolder* self);
	const gchar* (*get_display_name) (PluginFolder* self);
	GearyFolderSpecialUse (*get_used_as) (PluginFolder* self);
	PluginAccount* (*get_account) (PluginFolder* self);
	GVariant* (*to_variant) (PluginFolder* self);
};

struct _PluginComposerIface {
	GTypeInterface parent_iface;
	gboolean (*get_can_send) (PluginComposer* self);
	void (*set_can_send) (PluginComposer* self, gboolean value);
	void (*show) (PluginComposer* self);
	void (*edit_email) (PluginComposer* self, PluginEmailIdentifier* to_load, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*edit_email_finish) (PluginComposer* self, GAsyncResult* _res_, GError** error);
	void (*save_to_folder) (PluginComposer* self, PluginFolder* location);
};

GType plugin_account_get_type (void) G_GNUC_CONST;
GType plugin_email_identifier_get_type (void) G_GNUC_CONST;
GType plugin_folder_get_type (void) G_GNUC_CONST;
GType plugin_composer_get_type (void) G_GNUC_CONST;
gboolean plugin_composer_get_can_send (PluginComposer* self);
void plugin_composer_set_can_send (PluginComposer* self,
                                   gboolean value);
void plugin_composer_show (PluginComposer* self);
void plugin_composer_edit_email (PluginComposer* self,
                                 PluginEmailIdentifier* to_load,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_);
void plugin_composer_edit_email_finish (PluginComposer* self,
                                        GAsyncResult* _res_,
                                        GError** error);
void plugin_composer_save_to_folder (PluginComposer* self,
                                     PluginFolder* location);
static GType plugin_composer_get_type_once (void);

gboolean
plugin_composer_get_can_send (PluginComposer* self)
{
	g_return_val_if_fail (PLUGIN_IS_COMPOSER (self), FALSE);
	return PLUGIN_COMPOSER_GET_INTERFACE (self)->get_can_send (self);
}

void
plugin_composer_set_can_send (PluginComposer* self,
                              gboolean value)
{
	g_return_if_fail (PLUGIN_IS_COMPOSER (self));
	PLUGIN_COMPOSER_GET_INTERFACE (self)->set_can_send (self, value);
}

/**
     * Causes the composer to be made visible.
     *
     * The composer will be shown as either full-pane and in-window if
     * not a reply to a currently displayed conversation, inline and
     * in-window if a reply to an existing conversation being
     * displayed, or detached if there is already an in-window
     * composer being displayed.
     */
void
plugin_composer_show (PluginComposer* self)
{
	g_return_if_fail (PLUGIN_IS_COMPOSER (self));
	PLUGIN_COMPOSER_GET_INTERFACE (self)->show (self);
}

void
plugin_composer_edit_email (PluginComposer* self,
                            PluginEmailIdentifier* to_load,
                            GAsyncReadyCallback _callback_,
                            gpointer _user_data_)
{
	PLUGIN_COMPOSER_GET_INTERFACE (self)->edit_email (self, to_load, _callback_, _user_data_);
}

void
plugin_composer_edit_email_finish (PluginComposer* self,
                                   GAsyncResult* _res_,
                                   GError** error)
{
	PLUGIN_COMPOSER_GET_INTERFACE (self)->edit_email_finish (self, _res_, error);
}

/**
     * Sets the folder used to save the message being composed.
     *
     * Ensures email for both automatic and manual saving of the email
     * in the composer is saved to the given folder. This must be
     * called before calling {@link show}, and has no effect if called
     * afterwards.
     */
void
plugin_composer_save_to_folder (PluginComposer* self,
                                PluginFolder* location)
{
	g_return_if_fail (PLUGIN_IS_COMPOSER (self));
	PLUGIN_COMPOSER_GET_INTERFACE (self)->save_to_folder (self, location);
}

static void
plugin_composer_default_init (PluginComposerIface * iface,
                              gpointer iface_data)
{
	/**
	     * Determines if the email in the composer can be sent.
	     */
	g_object_interface_install_property (iface, g_param_spec_boolean ("can-send", "can-send", "can-send", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

/**
 * An object representing a composer for use by plugins.
 */
static GType
plugin_composer_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PluginComposerIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) plugin_composer_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType plugin_composer_type_id;
	plugin_composer_type_id = g_type_register_static (G_TYPE_INTERFACE, "PluginComposer", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (plugin_composer_type_id, GEARY_TYPE_BASE_OBJECT);
	return plugin_composer_type_id;
}

GType
plugin_composer_get_type (void)
{
	static volatile gsize plugin_composer_type_id__volatile = 0;
	if (g_once_init_enter (&plugin_composer_type_id__volatile)) {
		GType plugin_composer_type_id;
		plugin_composer_type_id = plugin_composer_get_type_once ();
		g_once_init_leave (&plugin_composer_type_id__volatile, plugin_composer_type_id);
	}
	return plugin_composer_type_id__volatile;
}

